<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../common/meta';
import { NextStep } from '@/components/common/index.vue';
import { filterFeaturesHelper } from '~/lib/processFeaturesHelper';

import {
  FeaturesLandingHero,
  FeaturesMenu,
  FeaturesCopyMedia,
} from '@/components/features/index';

import CategoriesTable from '@/components/common/categories-table.vue';

import TableLegend from '@/components/platform/table-legend.vue';

export default Vue.extend({
  components: {
    NextStep,
    FeaturesLandingHero,
    FeaturesMenu,
    FeaturesCopyMedia,
    CategoriesTable,
    TableLegend,
  },
  nuxtI18n: false,
  async asyncData({ $content, error }: any) {
    const categoriesObject = await $content('synced/categories').fetch();
    const featuresFetch = await $content('synced/features').fetch();

    try {
      const data = await $content(`platform`).fetch();
      const doc = await $content(`features`)
        .where({ slug: { $contains: ['features-partial'] } })
        .sortBy('slug', 'asc')
        .fetch();

      // START FEATURES TABLE CODE
      const table = {
        plan: [],
        create: [],
        verify: [],
        secure: [],
        package: [],
        deploy: [],
        monitor: [],
        govern: [],
      };

      // populate table arrays with category content by stage value
      Object.entries(categoriesObject).forEach(([_, value]) => {
        if (table[value.stage] && value.maturity && value.marketing !== false) {
          table[value.stage].push({
            name: value.name,
            stage: value.stage,
            documentation: value.documentation || null,
            direction: value.direction || null,
            marketing_page: value.marketing_page || null,
            maturity: value.maturity,
          });
        }
      });

      // START FEATURES TAB CODE
      const features = doc.reduce((previous: any, current: any) => {
        const mergedFeature = {
          ...previous,
          ...current,
        };

        return mergedFeature;
      });

      features.tabs.forEach((tab: any) => {
        const stageFormatted = tab.text.toLowerCase();
        const categoryList: any = [];
        Object.entries(categoriesObject).forEach(([key, value]) => {
          const itemValue = value as any;
          if (itemValue?.stage?.includes(stageFormatted)) {
            categoryList.push({ slug: key, name: itemValue?.name });
          }
        });

        const featuresArray = categoryList.map((category: any) => {
          return {
            ...category,
            features: filterFeaturesHelper(
              featuresFetch.features,
              features.content_config.filter_features_by,
              category.slug,
            ),
          };
        });
        features[stageFormatted].features = featuresArray;
      });

      return { data, features, table };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },

  data() {
    return {
      selectedTab: '',
      contentFilter: {
        plan: '',
      },
    };
  },
  head() {
    return getPageMetadata((this as any).data, this.$route.path);
  },
  mounted() {
    this.selectedTab = this.$route.query.stage
      ? this.$route.query.stage
      : (this as any).features.tabs[0].text.toLowerCase();

    if (!this.$route.query.stage) {
      this.$router.replace({
        path: '',
        query: { stage: this.selectedTab },
        replace: true,
      });
    }
  },
  methods: {
    onTabChange(tab: string) {
      this.selectedTab = tab;
      this.contentFilter = {
        plan: '',
      };
    },
  },
});
</script>

<template>
  <div class="platform-page">
    <section class="hero">
      <SlpContainer>
        <div class="flex">
          <div data-aos="fade-up" data-aos-duration="800">
            <div class="slp-mb-24 hero-copy">
              <SlpTypography
                tag="h1"
                variant="heading2-bold"
                class="slp-mb-8"
                >{{ data.header }}</SlpTypography
              >
              <SlpTypography tag="h2" variant="heading5">
                {{ data.subcopy }}
              </SlpTypography>
            </div>
            <div class="buttons">
              <SlpButton
                variant="primary"
                :href="data.cta_primary.href"
                :data-ga-name="data.cta_primary.data_ga_name"
                :data-ga-location="data.cta_primary.data_ga_location"
                >{{ data.cta_primary.text }}
              </SlpButton>
              <SlpButton
                variant="tertiary"
                :href="data.cta_secondary.href"
                :data-ga-name="data.cta_secondary.data_ga_name"
                :data-ga-location="data.cta_secondary.data_ga_location"
                >{{ data.cta_secondary.text }}
                <SlpIcon
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  slp-color="primary-50"
                  alt="Chevron Right Icon"
              /></SlpButton>
            </div>
          </div>

          <nuxt-img
            :src="data.img.url"
            :alt="data.img.alt"
            data-aos="fade-up"
            data-aos-duration="1000"
          />
        </div>
      </SlpContainer>
    </section>
    <section class="table-section">
      <div data-aos="fade-right" data-aos-duration="1000">
        <CategoriesTable :table="table" />
        <SlpContainer>
          <TableLegend />
        </SlpContainer>
      </div>
    </section>
    <SlpContainer>
      <FeaturesLandingHero :data="features.call_to_action" :is-hero="false" />
      <FeaturesMenu
        v-if="selectedTab"
        :tabs="features.tabs"
        :default-tab="selectedTab"
        :dropdown-label="features.dropdown_label"
        @tabChange="onTabChange"
      />
      <template v-if="features[selectedTab]">
        <FeaturesCopyMedia
          :data="features[selectedTab]['copy_media']"
          :features="features[selectedTab].features"
          :external="true"
        />
      </template>
    </SlpContainer>
    <section class="cards">
      <SlpContainer>
        <div class="card-grid">
          <a
            v-for="card in data.cards"
            :key="card.text"
            class="minimal-card"
            :href="card.link.href"
            :data-ga-name="card.link.data_ga_name"
            :data-ga-location="card.link.data_ga_location"
          >
            <div>
              <SlpIcon
                variant="marketing"
                :name="card.icon"
                hex-color="171321"
              /><SlpTypography variant="body2" tag="p">{{
                card.type
              }}</SlpTypography>
            </div>
            <SlpTypography class="card-text" variant="body1" tag="p">{{
              card.text
            }}</SlpTypography>
            <SlpButton variant="ghost"
              >Learn more <SlpIcon variant="product" name="chevron-lg-right"
            /></SlpButton>
          </a>
        </div>
      </SlpContainer>
    </section>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.platform-page {
  overflow-x: hidden;
}
.hero {
  padding: $spacing-64 0;
  background: $color-surface-700;
  color: $color-text-50;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-32 0;
  }

  .flex {
    display: flex;
    align-items: center;
    position: relative;
    justify-content: space-between;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
    }

    h1 {
      flex: 1 0 50%;

      @media (max-width: $breakpoint-md) {
        margin-bottom: $spacing-16;
      }
    }

    img {
      display: block;
      width: 100%;
      max-width: 650px;
    }
  }

  .hero-copy {
    @media (min-width: $breakpoint-md) {
      max-width: 480px;
    }
  }

  .buttons {
    margin-top: $spacing-16;
    display: flex;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
    }

    .slp-btn-primary {
      background: $color-surface-50;
      color: $color-text-300;
      margin-right: $spacing-8;

      &:hover {
        background: $color-surface-200;
      }
    }

    .slp-btn-tertiary {
      color: $color-text-50;

      .slp-icon {
        margin-left: $spacing-8;
      }

      @media (max-width: $breakpoint-md) {
        margin-bottom: $spacing-48;
      }
    }

    .slp-btn-primary,
    .slp-btn-tertiary {
      @media (max-width: $breakpoint-md) {
        justify-content: center;
      }
    }
  }
}

::-webkit-scrollbar {
  display: none;
}
.table-section {
  padding: 0 0 $spacing-64 0;
  background: $color-surface-700;
  color: $color-text-50;
  position: relative;
  width: 100%;

  &:deep {
    .stage-name {
      font-size: $text-body-2-bold;
      line-height: $line-height-body-2-bold;
      font-weight: $font-weight-bold;
      color: $color-surface-700;
      position: relative;
      padding-left: $spacing-16;
      padding-top: $spacing-4;
      padding-bottom: $spacing-4;
      background: $color-surface-50;
    }

    .table .column .sub-column .stage-name:not(.last):after {
      content: url('data:image/svg+xml, <svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M5.22 2.22a.75.75 0 011.06 0l5.252 5.252a.75.75 0 010 1.06L6.28 13.784a.75.75 0 11-1.06-1.06l4.72-4.723L5.22 3.28a.75.75 0 010-1.06z"></path></svg>');
      position: absolute;
      font-size: 20px;
      top: 6%;
      right: 7%;
      width: 15px;
      z-index: 1;
      padding: $spacing-4;
      transform: scale(1.5);
    }

    // Very last category's last subcolumn's arrow
    .stage-name.last {
      width: 92%;
      &::after {
        color: $color-surface-50;
        border-left: 13px solid;
        border-top: 13px solid transparent;
        border-bottom: 13px solid transparent;
        display: inline-block;
        content: '';
        position: absolute;
        right: -13px;
        top: 50%;
        transform: translateY(-50%);
      }
    }

    .column {
      min-height: 450px;
      height: 100%;
    }

    .features {
      padding: $spacing-16;
      a,
      p {
        font-size: $text-body-3;
        line-height: $line-height-body-3;
        margin-bottom: $spacing-8;
      }

      a:hover {
        text-decoration: underline;
      }
    }

    .mature,
    .early,
    .planned {
      font-weight: $font-weight-bold;
    }

    .mature {
      color: $color-text-50;
    }

    .early {
      color: #ac9ccb;
    }

    .planned {
      color: #dc9840;
    }
  }
}

.cards {
  background: $color-surface-800;

  .card-grid {
    display: flex;
    justify-content: space-between;
    align-items: flex-start;
    padding: $spacing-96 0;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
      padding: $spacing-64 0;
    }
  }

  .minimal-card {
    max-width: 350px;
    min-height: 272px;
    width: 100%;
    background: $color-surface-50;
    padding: $spacing-32 $spacing-16;
    transition: border-radius 0.3s ease-in;

    &:hover {
      border-radius: 0 0 90px 0;
    }

    @media (max-width: $breakpoint-md) {
      margin-bottom: $spacing-24;
    }

    div {
      display: flex;

      p {
        margin-left: $spacing-8;
        color: $color-text-300;
      }
    }

    .card-text {
      color: $color-text-300;
      margin-top: $spacing-24;
      margin-bottom: $spacing-64;
    }

    .slp-btn-ghost {
      color: inherit;
      font-weight: $font-weight-bold;

      .slp-icon {
        margin-left: $spacing-8;
      }
    }
  }
}
</style>
